package de.moritzruth.lampenfieber

import de.moritzruth.theaterdsl.show.PropPosition
import de.moritzruth.theaterdsl.show.PropsBuilderMap

object PropConfigurations {
    fun empty(props: PropsBuilderMap) {
        PropPosition.values().forEach {
            props[it] = null
        }
    }

    fun classroom(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "grüne + bemalte + grüne Rückwand"
        props[PropPosition.LEFT] = "7 Stühle"
        props[PropPosition.RIGHT] = "7 Stühle, Plakat"
        props[PropPosition.PROSCENIUM_LEFT] = "E-Piano mit Stuhl"
    }

    fun tvRoom(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "2 schwarze Wände"
        props[PropPosition.RIGHT] = "Sofa"
    }

    fun casting(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "grüne Wand"
        props[PropPosition.LEFT] = "grüne Wand"
        props[PropPosition.CENTER] = "Casting-Schild"
        props[PropPosition.RIGHT] = "schwarze Wand"
        props[PropPosition.PROSCENIUM_LEFT] = "E-Piano mit Stuhl"
    }

    fun calling(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "schwarze Wand"
        props[PropPosition.LEFT] = "grüne Wand, Stuhl bei Markierung"
        props[PropPosition.RIGHT] = "grüne Wand, Stuhl bei Markierung"
    }

    fun bathroom(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "Duschvorhang + Toilette + Toilette + Duschvorhang"
        props[PropPosition.LEFT] = "Waschbecken, Hocker, Spiegel"
        props[PropPosition.RIGHT] = "Waschbecken, Hocker, Spiegel"
    }

    fun richy(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "2 blaue Wände"
        props[PropPosition.LEFT] = "3 Stühle"
        props[PropPosition.RIGHT] = "2 Stühle"
    }

    fun backstage(props: PropsBuilderMap) {
        empty(props)
        props[PropPosition.BACKDROP] = "grüne + schwarze + grüne Rückwand"
    }
}
