package de.moritzruth.lampenfieber.device

import de.moritzruth.theaterdsl.device.Device
import de.moritzruth.theaterdsl.device.PercentageDV
import de.moritzruth.theaterdsl.dmx.DmxAddress
import de.moritzruth.theaterdsl.dmx.DmxDataWriter
import kotlinx.collections.immutable.persistentSetOf

class SimpleDimmer(channel: DmxAddress) : Device {
    override val firstChannel = channel
    override val numberOfChannels: UInt = 1u

    override fun writeDmxData(writer: DmxDataWriter, isLightBehindCurtainOn: Boolean) {
        writer.writePercentage(brightness.getCurrentValue())
    }

    val brightness = PercentageDV()

    override val dvs = persistentSetOf(brightness)
}