package de.moritzruth.theaterdsl.dmx

import de.moritzruth.theaterdsl.value.Percentage
import kotlin.math.roundToInt

@JvmInline
value class DmxValue(val value: UByte) : Comparable<UByte> {
    companion object {
        val VALUE_RANGE = 0u..255u
    }

    override fun compareTo(other: UByte): Int = value.compareTo(other)
}

/**
 * @param startAtOne Whether the output range is `1..255` or `0..255`.
 */
fun Percentage.roundToDmxValue(startAtOne: Boolean = false): DmxValue =
    if (startAtOne) DmxValue(((value * (DmxValue.VALUE_RANGE.last.toDouble() - 1.0)).roundToInt() + 1).toUByte())
    else DmxValue((value * DmxValue.VALUE_RANGE.last.toDouble()).roundToInt().toUByte())