package de.moritzruth.theaterdsl.dmx

class PerDeviceDmxDataWriter(val data: UByteArray): DmxDataWriter {
    private var nextIndex = 0
    private var remainingWrites = 0u

    override fun writeRaw(value: DmxValue) {
        if (remainingWrites == 0u) throw IndexOutOfBoundsException(nextIndex)
        data[nextIndex] = value.value
        nextIndex += 1
        remainingWrites -= 1u
    }

    fun reset(universe: Int, firstAddress: DmxAddress, numberOfChannels: UInt) {
        nextIndex =
            (universe * DmxAddress.VALUE_RANGE.last.toInt()) + firstAddress.value.toInt() - 1 // DMX addresses are one-based, array indices are zero-based
        remainingWrites = numberOfChannels
    }
}
