package de.moritzruth.theaterdsl.util

import kotlinx.serialization.KSerializer
import kotlinx.serialization.descriptors.SerialDescriptor
import kotlinx.serialization.encoding.Decoder
import kotlinx.serialization.encoding.Encoder
import kotlinx.serialization.serializer
import kotlin.time.Duration
import kotlin.time.Duration.Companion.milliseconds

object DurationAsMillisecondsSerializer : KSerializer<Duration> {
    override val descriptor: SerialDescriptor = serializer<Duration>().descriptor

    override fun deserialize(decoder: Decoder): Duration =
        decoder.decodeLong().milliseconds

    override fun serialize(encoder: Encoder, value: Duration) {
        encoder.encodeLong(value.inWholeMilliseconds)
    }
}