package de.moritzruth.theaterdsl.value

import kotlin.math.pow
import kotlin.math.roundToInt

val IntProgression.delta: Int get() = last - first
val ClosedFloatingPointRange<Double>.delta: Double get() = endInclusive - start

fun Int.transfer(from: IntRange, to: IntRange): Int =
    ((this - from.first) / from.delta) * to.delta + to.first

fun Double.transfer(from: ClosedFloatingPointRange<Double>, to: ClosedFloatingPointRange<Double>): Double =
    ((this - from.start) / from.delta) * to.delta + to.start

fun Double.toString(decimalPlaces: Int): String {
    val s = (this * (10f.pow(decimalPlaces))).roundToInt().toString().padStart(decimalPlaces + 1, '0')
    return s.dropLast(decimalPlaces) + "." + s.takeLast(decimalPlaces)
}
